jv.number

## Class PuColorPicker

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - java.awt.Panel
      - - jv.object.PsPanel
        - - jv.number.PuColorPicker

- All Implemented Interfaces:
    java.awt.event.MouseListener, java.awt.event.MouseMotionListener, java.awt.image.ImageObserver, java.awt.MenuContainer, java.io.Serializable, java.util.EventListener, javax.accessibility.Accessible, PsUpdateIf

      public class PuColorPicker
      extends PsPanel
      implements java.awt.event.MouseListener, java.awt.event.MouseMotionListener

  Panel with rainbow color wheel and RGB and brightness sliders. Use method `#getColor` to get the current color choice.
  See Also:
    `PdColor_IP`, `PdColor_Dialog`, Serialized Form
  Author:
    Konrad Polthier
  Version:
    24.11.17, 3.10 revised (kp) Four greyscale corner colors made publicly accessible as reference.
    11.08.03, 3.00 revised (kp) Handling of brightness improved.
    20.12.01, 2.50 revised (ep) Internationalization.
    20.11.00, 2.40 revised (kp) Method getWheel() made public and static.
    13.11.00, 2.30 revised (kp) Sliders fill space if panel is enlarged.
    12.11.00, 2.20 revised (kp) Class ColorWheel completely removed.
    01.11.00, 2.10 revised (kp) On-the-fly-color-wheel finished.
    30.10.00, 2.00 revised (kp) Produce color wheel on the fly.
    02.08.00, 1.26 revised (kp) Static variable of file name of color wheel moved to PsConfig.
    09.05.00, 1.25 revised (kp) Use of CodeBase removed when constructing PsImage.
    22.10.99, 1.20 revised (kp) Check if image has been loaded.
    07.08.99, 1.10 revised (kp) Converted to AWT 1.1
    00.00.98, 1.00 created (kp)

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.BaselineResizeBehavior`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `PIXELBLACK`
    `static int` | `PIXELDARKGREY`
    `static int` | `PIXELLIGHTGREY`
    `static int` | `PIXELWHITE`

    - ### Fields inherited from class jv.object.PsPanel

      `BORDER_GROOVE, BORDER_LINE, BORDER_LINETOP, BORDER_NONE, BORDER_SUNK, BOUNDARY, BOUNDARY_EXT, CONFIG, CONFIG_EXT, INFO, INFO_EXT, LABEL, LABEL_EXT, MATERIAL, MATERIAL_EXT, ORIENT_GUIDE, ORIENT_HORIZONTAL, ORIENT_VERTICAL, TEXTURE, TEXTURE_EXT, VECTOR, VECTOR_EXT`

    - ### Fields inherited from class java.awt.Component

      `BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PuColorPicker(java.awt.Color initColor)` Create a new color inspector with color wheel for picking colors.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.awt.Color` | `getColor()` Get current color selection.
    `java.awt.Color` | `getDefColor()` Get the default color.
    `static java.awt.Image` | `getWheel(int imgWidth, int imgHeight, int brightness, int[] pix)` Compute a color wheel in a square panel of size width == height.
    `static int[]` | `getWheelAsInt(int imgWidth, int imgHeight, int brightness, int[] pix)` Compute a color wheel in a square panel of size width == height.
    `void` | `init()` Provides layout and adds internal components.
    `void` | `mouseClicked(java.awt.event.MouseEvent event)` Do nothing.
    `void` | `mouseDragged(java.awt.event.MouseEvent event)` Invoke mousePressed.
    `void` | `mouseEntered(java.awt.event.MouseEvent event)` Do nothing.
    `void` | `mouseExited(java.awt.event.MouseEvent event)` Do nothing.
    `void` | `mouseMoved(java.awt.event.MouseEvent event)` Do nothing.
    `void` | `mousePressed(java.awt.event.MouseEvent event)` There are two panels which issue mouse events: If user clicks into the color wheel then current color is set.
    `void` | `mouseReleased(java.awt.event.MouseEvent event)`
    `void` | `setColor(java.awt.Color rgbColor)` Set current color and values of rgb sliders.
    `void` | `setDefColor(java.awt.Color rgbColor)` Set the default color.
    `boolean` | `update(java.lang.Object event)` Update dialog if color slider or brightness slider has changed.

    - ### Methods inherited from class jv.object.PsPanel

      `addLabelComponent, addLine, addLine, addSubTitle, addTextField, addTitle, drawBorder, drawBorder, drawBorder, drawBorder, drawText, getFather, getInsets, getLanguage, getPanelVersion, getPreferredSize, getTitle, getTitle, getTitle, hasTitle, instanceOf, paint, removeTitle, select, setBackColor, setBorderType, setEnabled, setImage, setInsetSize, setInsetSizeHorizontal, setInsetSizeVertical, setLabel, setLabel, setOutOfDate, setParent, setPreferredSize, setSelectedCheckbox, setState, setText, setText, setTitle, setVisible, update`

    - ### Methods inherited from class java.awt.Panel

      `addNotify, getAccessibleContext`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getListeners, getMaximumSize, getMinimumSize, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, isValidateRoot, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, remove, remove, removeAll, removeContainerListener, removeNotify, setComponentZOrder, setFocusCycleRoot, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, setLayout, transferFocusDownCycle, validate`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, dispatchEvent, enable, enable, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getToolkit, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, printAll, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocusInWindow, reshape, resize, resize, revalidate, setBackground, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setMaximumSize, setMinimumSize, setName, setPreferredSize, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface jv.object.PsUpdateIf

      `getName`

- - ### Field Detail

    - #### PIXELWHITE

          public static final int PIXELWHITE

      See Also:
        Constant Field Values

    - #### PIXELLIGHTGREY

          public static final int PIXELLIGHTGREY

      See Also:
        Constant Field Values

    - #### PIXELDARKGREY

          public static final int PIXELDARKGREY

      See Also:
        Constant Field Values

    - #### PIXELBLACK

          public static final int PIXELBLACK

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### PuColorPicker

          public PuColorPicker(java.awt.Color initColor)

      Create a new color inspector with color wheel for picking colors. Note, PsConfig must be initialized prior to this call since PsImage needs the codeBase.
      Version:
        08.10.00, 1.30 revised (kp) Use static method PsImage#getImage instead of creating an instance of PsImage.
        09.05.00, 1.25 revised (kp) Use of CodeBase removed when constructing PsImage.

  - ### Method Detail

    - #### init

          public void init()

      Description copied from class: `PsPanel`
      Provides layout and adds internal components.
      Overrides:
        `init` in class `PsPanel`

    - #### mousePressed

          public void mousePressed(java.awt.event.MouseEvent event)

      There are two panels which issue mouse events: If user clicks into the color wheel then current color is set. If user clicks into the default color field, then current color is reset.
      Specified by:
        `mousePressed` in interface `java.awt.event.MouseListener`

    - #### mouseMoved

          public void mouseMoved(java.awt.event.MouseEvent event)

      Do nothing.
      Specified by:
        `mouseMoved` in interface `java.awt.event.MouseMotionListener`

    - #### mouseExited

          public void mouseExited(java.awt.event.MouseEvent event)

      Do nothing.
      Specified by:
        `mouseExited` in interface `java.awt.event.MouseListener`

    - #### mouseEntered

          public void mouseEntered(java.awt.event.MouseEvent event)

      Do nothing.
      Specified by:
        `mouseEntered` in interface `java.awt.event.MouseListener`

    - #### mouseClicked

          public void mouseClicked(java.awt.event.MouseEvent event)

      Do nothing.
      Specified by:
        `mouseClicked` in interface `java.awt.event.MouseListener`

    - #### mouseDragged

          public void mouseDragged(java.awt.event.MouseEvent event)

      Invoke mousePressed.
      Specified by:
        `mouseDragged` in interface `java.awt.event.MouseMotionListener`

    - #### mouseReleased

          public void mouseReleased(java.awt.event.MouseEvent event)

      Specified by:
        `mouseReleased` in interface `java.awt.event.MouseListener`

    - #### getDefColor

          public java.awt.Color getDefColor()

      Get the default color.

    - #### setDefColor

          public void setDefColor(java.awt.Color rgbColor)

      Set the default color.

    - #### getColor

          public java.awt.Color getColor()

      Get current color selection.

    - #### setColor

          public void setColor(java.awt.Color rgbColor)

      Set current color and values of rgb sliders. Value of brightness slider is not modified.

    - #### update

          public boolean update(java.lang.Object event)

      Update dialog if color slider or brightness slider has changed.
      Specified by:
        `update` in interface `PsUpdateIf`
      Overrides:
        `update` in class `PsPanel`
      Parameters:
        `event` - carries a lot of information
      Returns:
        true if event has been handled, otherwise false
      See Also:
        `PsObject`, `PsUpdateIf.getFather()`, `PsUpdateIf.setParent(PsUpdateIf)`

    - #### getWheelAsInt

          public static int[] getWheelAsInt(int imgWidth,
                                            int imgHeight,
                                            int brightness,
                                            int[] pix)

      Compute a color wheel in a square panel of size width == height. Shows all RGB color triples which have the same maximum equal to the given parameter brightness.
      Parameters:
        `imgWidth` - width of color wheel image in pixel
        `imgHeight` - height of color wheel image in pixel
        `brightness` - brightness of image in [0,255]
        `pix` - array stores color as integer, maybe null.
      Returns:
        updated pixel array
      Since:
        JavaView 2.90.001
      Version:
        25.11.06, 2.10 revised (kp) Colored disk increased by one pixel to improve disk.
        11.08.03, 2.00 revised (kp) Method body moved from getWheel(), optimize wheel computation.
        20.11.00, 1.50 revised (kp) Pass pix array as argument to make method static.
        30.10.00, 1.00 created (kp)

    - #### getWheel

          public static java.awt.Image getWheel(int imgWidth,
                                                int imgHeight,
                                                int brightness,
                                                int[] pix)

      Compute a color wheel in a square panel of size width == height. Shows all RGB color triples which have the same maximum equal to the given parameter brightness.
      Parameters:
        `imgWidth` - width of color wheel image in pixel
        `imgHeight` - height of color wheel image in pixel
        `brightness` - brightness of image in [0,255]
        `pix` - array stores color as integer, maybe null.
      Returns:
        newly created image
      Version:
        11.08.03, 2.00 revised (kp) Body of method moved to getWheelAsInt.
        20.11.00, 1.50 revised (kp) Pass pix array as argument to make method static.
        30.10.00, 1.00 created (kp)

"

The software JavaView? is copyright protected. All Rights Reserved.
"